"""
This is a setup.py script generated by py2applet

Usage:
    python setup.py py2app

Building everything from scratch:

Download and install Python 2.6.2 binary installer : http://www.python.org/download/releases/2.6.2/
Download and install Tcl/Tk 8.5 binaries : http://www.activestate.com/activetcl/
Download Python 2.6.2 source : http://www.python.org/download/releases/2.6.2/


tar xjf Python-2.6.2.tar.bz2
cd Python-2.6.2
./configure --enable-framework --enable-universalsdk 
make
cp build/lib.macosx-10.3-fat-2.6/_tkinter.so /Library/Frameworks/Python.framework/Versions/2.6/lib/python2.6/lib-dynload/


python ~/work/bin/ez_setup.py
cd ~/work/plink; python setup.py install

python -m easy_install ipython
python -m easy_install py2app
sudo touch /Library/Frameworks/Python.framework/Versions/2.6/Resources/version.plist
python -m easy_install mercurial
python -m easy_install sphinx
python -m easy_install pyx==0.12.1
....


Note for 8.4.19 on needs to rebuild libToGL.
For 8.5.7....
"""

from setuptools import setup, Command
import os
try:
  import pyx
except ImportError:
  raise ValueError('Please install PyX version 0.12.1.')

class clean(Command):
    user_options = []
    def initialize_options(self):
        pass 
    def finalize_options(self):
        pass
    def run(self):
        os.system("rm -rf build dist *.pyc")

APP = ['SnapPy.py']
DATA_FILES = []
OPTIONS = {'argv_emulation': False,
           'excludes': 'scipy,numpy,wx,wxversion,wxPython,email,matplotlib',
           'packages': 'snappy,IPython,plink,cypari,spherogram,pyx',
           'includes': 'gzip,tarfile,readline,pydoc,fractions',
           'iconfile': 'icons/SnapPy.icns',
}

setup(
    app=APP,
    data_files=DATA_FILES,
    options={'py2app': OPTIONS},
    setup_requires=['py2app'],
    cmdclass   = {'clean' : clean},
)
